var mzk_config = {
    base_domain: "http://rest.iwesta.com/",
    //base_domain: "http://127.0.0.1:9550/",
    vip_base_domain: "",
    app_ver: "1.1.0",
    browser_ver: "",
    device_name: "chrome",
    curr_server_id: "",
    lang: chrome.i18n.getUILanguage(),
    'notice': {title: "开通VIP可获取更高速加速通道", url: "login.html"},
    'vip_notice': {title: "iWest官网 https://iwests.com", url: "https://iwests.com"},
    api_ver: "1.1",
    uninstall_url: "",
    read_vip_exp_count: 0,
    is_ff_privateBrowsingAllowed: false,
    proxy_permissions_namewhilelist: ["IDM Integration Module"]
};
var mzk_pac_config = {
    geoip_data: "",
    testdomain: {},
    test_pac_domain: [],
    auto_test_server_rank: [],
    geoip_switch: true,
};
var mzk_user_token = "";
var mzk_is_connect = false;
var mzk_select_server_info = false;
var mzk_connect_mode = "smart";
var mzk_user_info = {};
var mzk_server_id = '';
mzk_config.read_vip_exp_count = 1;


function getChromeVersion() {
    var raw = navigator.userAgent.match(/Chrom(e|ium)\/([0-9]+)\./);
    return raw ? parseInt(raw[2], 10) : false;
}

function getFirefoxVersion() {
    var raw = navigator.userAgent.match(/Firefox\/([0-9]+)\./);
    return raw ? parseInt(raw[1], 10) : false;
}

function getEdgeVersion() {
    var raw = navigator.userAgent.match(/Edg\/([0-9]+)\./);
    return raw ? parseInt(raw[1], 10) : false;
}

function getOperaVersion() {
    var raw = navigator.userAgent.match(/OPR\/([0-9]+)\./);
    return raw ? parseInt(raw[1], 10) : false;
}

function user_uninstall() {
    if (typeof mzk_user_info.u_type !== "undefined" && mzk_user_info.u_type === "parent") {
        user_logout();
    }
}

function load_default_data(_acallback) {
    $.get(chrome.extension.getURL("/localdb/geoip.txt"), function (data) {
        mzk_pac_config.geoip_data = data;
        if (_acallback)
            _acallback();
    });
}

function set_localdb_cache(key, data, update) {
    localStorage.setItem("localcache_" + key, JSON.stringify({data: data, last_update: update}));
}

chrome.runtime.onMessage.addListener(
    function (request, sender, sendResponse) {
        if (request.cmd == "get_base_domain") {
            sendResponse({url: mzk_config.base_domain});
        } else if (request.cmd == "check_proxy_permissions") { // 检测冲突app
            sendResponse({result: 'ok'});
            check_proxy_permissions();
        } else {
            sendResponse({result: "error", message: "Invalid 'cmd'"});
        }
        return true;
    });

var mzk_backup_server = [
    "http://rest.iwesta.com/",
    "http://rest.iwestv.com/",
    "http://rest.iwests.com/",
];

var mzk_vip_backup_server = [
    "http://rest.iwesta.com/",
    "http://rest.iwestv.com/",
    "http://rest.iwests.com/",
];

mzk_config.vip_base_domain = "http://rest.iwestv.com/";


chrome.storage.local.get(null, function (result) {
    console.log(result)
    mzk_is_connect = result.mzk_is_connect;
    mzk_server_id = result.mzk_server_id;
    if (result.mzk_select_server_info) {
        mzk_select_server_info = result.mzk_select_server_info;
    }

    if (typeof result.mzk_geoip_switch !== "undefined") {
        mzk_pac_config.geoip_switch = result.mzk_geoip_switch;
    }

    if (typeof result.backup_url_domain !== "undefined") {
        mzk_backup_server = result.backup_url_domain;
        mzk_config.base_domain = mzk_backup_server[0];
    }

    if (typeof result.backup_vip_domain !== "undefined") {
        mzk_vip_backup_server = result.backup_vip_domain;
    }

    if (typeof result.proxy_permissions_namewhilelist !== "undefined") {
        mzk_config.proxy_permissions_namewhilelist = result.proxy_permissions_namewhilelist;
    }

    if (result.uinfo) {
        mzk_user_info = JSON.parse(result.uinfo);
    }

    var browser_ver = getFirefoxVersion();
    if (browser_ver) {
        mzk_config.device_name = "firefox";
        mzk_config.browser_ver = browser_ver;
        check_firefox_privateBrowsingAllowed();
    } else if (navigator.userAgent.match(/Edg\/([0-9]+)\./)) {
        browser_ver = getEdgeVersion();
        mzk_config.device_name = "edge";
        mzk_config.browser_ver = browser_ver;
    } else if (navigator.userAgent.match(/OPR\/([0-9]+)\./)) {
        browser_ver = getOperaVersion();
        mzk_config.device_name = "opera";
        mzk_config.browser_ver = browser_ver;
    } else {
        mzk_config.browser_ver = getChromeVersion();
    }

    var Manifest = chrome.runtime.getManifest();
    mzk_config.app_ver = Manifest.version;

    check_proxy_permissions();
    get_user_token(function () {
        load_default_data();
        if (mzk_is_connect) {
            open_vpn();
        }
    });
});

function MZK_getJSON_DATA(API, send_data, _rcallback) {
    if (!send_data)
        send_data = {};
    send_data.appver = mzk_config.app_ver;
    send_data.device_name = mzk_config.device_name;
    send_data.token = mzk_user_token;
    send_data.curr_server_id = mzk_config.curr_server_id;
    send_data.runtime_id = chrome.runtime.id;
    send_data.lang = mzk_config.lang;
    if (mzk_user_info.is_vip) {
        var curr_api_url = mzk_config.vip_base_domain;
        var curr_backup_server_list = mzk_vip_backup_server;
    } else {
        var curr_api_url = mzk_config.base_domain;
        var curr_backup_server_list = mzk_backup_server;
    }
    var curr_retryLimit = curr_backup_server_list.length;
    var time = new Date().getTime()
    $.ajax({
        url: curr_api_url + API,
        type: 'POST',
        dataType: "json",
        data: send_data,
        timeout: 6000,
        tryCount: 0,
        retryLimit: curr_retryLimit,
        headers: {
            t: time,
            sign: MD5.hex_md5(time + "cef949d30332cf00bfabba46ac5c36e3")
        },
        success: function (data) {
            if (typeof data.msgtype !== "undefined" && typeof data.msgdata !== "undefined" && data.msgtype == "Encrypt") {
                data = JSON.parse(CryptoJSAesDecrypt(data.msgdata));
            }
            if (_rcallback) {
                _rcallback(data);
            }
        },
        error: function (xhr, textStatus, errorThrown) {
            var err = textStatus + ", " + errorThrown;
            console.log("Err:" + err);
            if (this.tryCount < this.retryLimit) {
                this.url = curr_backup_server_list[this.tryCount] + API;
                if (mzk_user_info.is_vip) mzk_config.vip_base_domain = curr_backup_server_list[this.tryCount]; else mzk_config.base_domain = curr_backup_server_list[this.tryCount];
                this.tryCount++;
                $.ajax(this);
                return;
            } else {
                if (!/getsession/igm.test(API)) {
                    var err = textStatus + ", " + errorThrown;
                    //show_notifications_msg('network_error_' + Math.random(), get_lan_msg("error_network"));
                }
            }
            return;
        }
    });
}

function CryptoJSAesDecrypt(encrypted_json_string) {
    var obj_json = JSON.parse(encrypted_json_string);
    var encrypted = obj_json.ciphertext;
    var salt = CryptoJS.enc.Hex.parse(obj_json.salt);
    var iv = CryptoJS.enc.Hex.parse(obj_json.iv);
    var key = CryptoJS.PBKDF2(mzk_user_token, salt, {hasher: CryptoJS.algo.SHA512, keySize: 64 / 8, iterations: 999});
    var decrypted = CryptoJS.AES.decrypt(encrypted, key, {iv: iv});
    return decrypted.toString(CryptoJS.enc.Utf8);
}

function get_user_token(_acallback) {
    chrome.storage.local.get(['mzk_token', 'uinfo', 'loginout'], function (result) {
        if (result.mzk_token) {
            mzk_user_token = result.mzk_token;
            mzk_user_info = JSON.parse(result.uinfo);
            KeepLive_Session()
        }

        if (result.loginout) {
            window.open(chrome.runtime.getURL("login.html?/muser/login"), "iwestLogin");
            return false;
        }

        if (!result.mzk_token || !result.uinfo) {
            guest_login(function () {
                if (_acallback)
                    _acallback();
            })
            return false;
        }
    });
}

function guest_login(_rlogincallback) {
    MZK_getJSON_DATA("auth/guest", {}, function (data) {
        if (data.status == 0) {
            data = data.data
            mzk_user_info = data.uinfo;
            mzk_user_token = data.token;
            chrome.storage.local.set({mzk_token: data.token, uinfo: JSON.stringify(data.uinfo)}, function () {
                mzk_select_server_info = false;
                mzk_is_connect = false;
                chrome.browserAction.setPopup({popup: "main.html"});
                check_proxy_permissions();
                get_default_server(function () {
                    open_vpn()
                    if (mzk_user_info.is_vip) {
                        KeepLive_Session();
                    }
                    if (_rlogincallback) {
                        _rlogincallback(data);
                    }
                });
            });
        } else {
            if (_rlogincallback) {
                _rlogincallback(data);
            }
        }
    });
}

function user_logout(_acallback) {
    MZK_getJSON_DATA("auth/loginout", {},
        function (data) {
            close_vpn(function () {
                chrome.storage.local.remove(['uinfo', 'mzk_select_server_info', 'mzk_is_connect', 'mzk_connect_mode', 'mzk_token'], function () {
                    if (_acallback)
                        _acallback();
                    mzk_server_id = '';
                    mzk_user_token = "";
                    mzk_user_info = {};
                    Mzk_iTestSpeed.top_server = [];
                });
            });
        }
    );
}


var calls = {};
var DEFAULT_RETRY_ATTEMPTS = 5;
chrome.webRequest.onAuthRequired.addListener(function (details, callback) {
        console.log(details)
        var idstr = details.requestId.toString();
        if (details.statusLine === 'HTTP/1.1 401 Unauthorized West') {
            if (!(idstr in calls)) {
                calls[idstr] = 0;
            }
            calls[idstr] = calls[idstr] + 1;
            var retry = parseInt(localStorage["proxy_retry"]) || DEFAULT_RETRY_ATTEMPTS || 5;
            if (calls[idstr] >= retry) {
                calls = {};
                return ({
                    cancel: true
                });
            }
            var username = "";
            var password = "";
            if (typeof mzk_user_info.p_user !== "undefined") {
                username = mzk_user_info.p_user;
                password = mzk_user_info.p_pass;
            }

            if (username && password) {
                return {
                    authCredentials: {
                        username: username,
                        password: password
                    }
                };
            }
            // callback({
            //     authCredentials: {"username": username, "password": password}
            // });
        }
    },
    {urls: ["<all_urls>"]},
    ['blocking']
    //{urls: ["<all_urls>"]},["asyncBlocking"]
);

function goto_vip_tips_func(details) {
    var redirectUrl = chrome.extension.getURL("/helper/only_vip_site.html");
    if (details.type == "main_frame") {
        if (mzk_config.device_name == "firefox") {
            return {cancel: true};
        } else return {redirectUrl: redirectUrl};
    } else {
        return {cancel: true};
    }
}

function enable_vip_site_tips() {
    if (mzk_user_info.is_vip) {
        disabled_vip_site_tips();
        return;
    }
    if (typeof Mzk_iTestSpeed.ipinfo !== "undefined" && typeof Mzk_iTestSpeed.ipinfo.data !== "undefined" && typeof Mzk_iTestSpeed.ipinfo.data.country !== "undefined" && Mzk_iTestSpeed.ipinfo.data.country != "中国") {
        disabled_vip_site_tips();
        return;
    }
    if (chrome.webRequest.onBeforeRequest.hasListener(goto_vip_tips_func)) {
        return;
    }
    chrome.webRequest.onBeforeRequest.addListener(
        goto_vip_tips_func,
        {
            urls: [
                "*://*.facebook.com/*",
                "*://twitter.com/*",
                "*://drive.google.com/*",
                "*://*.youtube.com/*"
            ]
        },
        ["blocking"]
    );
}

function disabled_vip_site_tips() {
    if (chrome.webRequest.onBeforeRequest.hasListener(goto_vip_tips_func)) {
        chrome.webRequest.onBeforeRequest.removeListener(goto_vip_tips_func);
    }
}

class Mzk_Kepplive_Service {
    static sync_current_server_info(sid) {
        if (mzk_select_server_info) {
            MZK_getJSON_DATA("/api/get_server", {sid: sid}, function (data) {
                if (data.status == 0) {
                    if (data.data.active !== 1) {
                        get_default_server(function () {
                            if (mzk_is_connect) open_vpn();
                        });
                    } else {
                        mzk_select_server_info = data.data;
                        chrome.storage.local.set({mzk_select_server_info: data.data}, function () {
                            mzk_server_id = data.data.line_sn;
                            mzk_select_server_info = data.data;
                            if (mzk_is_connect) open_vpn();
                        });
                    }
                }
            });
        }
    }

    static sync_testdomain(auto_test_server) {
        mzk_pac_config.testdomain = auto_test_server;
        var test_pac_domain = {};
        $.each(auto_test_server, function (i, k) {
            test_pac_domain[k.testdomain] = k.server;
        });
        mzk_pac_config.test_pac_domain = test_pac_domain;
        open_vpn(function () {
            Mzk_iTestSpeed.Start();
        });
    }
}


function KeepLive_Session() {
    if (!mzk_is_connect) return;
    var ipdata = {};
    if (typeof Mzk_iTestSpeed.ipinfo !== "undefined" && typeof Mzk_iTestSpeed.ipinfo.data !== "undefined") ipdata = Mzk_iTestSpeed.ipinfo.data;
    MZK_getJSON_DATA("api/check", {geoip_info: ipdata}, function (data) {
        if (data.status == 0) {
            data = data.data
            if (data.is_user_change || data.uinfo.vip_level != mzk_user_info.vip_level) {
                get_default_server(function () {
                    open_vpn();
                });
            }
            chrome.storage.local.set({uinfo: JSON.stringify(data.uinfo)});
            mzk_user_info = data.uinfo;

            if ((mzk_select_server_info.vip_level > mzk_user_info.vip_level) || (mzk_user_info.vip_level > 1 && mzk_select_server_info.vip_level < 2)) {
                get_default_server(function () {
                    open_vpn();
                });
            }

            mzk_config.vip_notice = data.vip_notice;
            if (mzk_select_server_info && data.server_last_update !== mzk_select_server_info.last_update) {
                Mzk_Kepplive_Service.sync_current_server_info(mzk_select_server_info.line_sn);
            }

            // if (data.auto_test_server.length > 2 && mzk_select_server_info.line_mode == "smart") {
            //     Mzk_Kepplive_Service.sync_testdomain(data.auto_test_server);
            // }

            if (typeof data.vip_enable_tips !== "undefined" && data.vip_enable_tips == true) {
                enable_vip_site_tips();
            }

            if (typeof data.backup_domain_server !== "undefined") {
                chrome.storage.local.set({"backup_url_domain": data.backup_domain_server});
                mzk_backup_server = data.backup_domain_server;
            }

            if (typeof data.vip_backup_domain_server !== "undefined") {
                chrome.storage.local.set({"backup_vip_domain": data.vip_backup_domain_server});
                mzk_vip_backup_server = data.vip_backup_domain_server;
            }

            if (typeof data.proxy_namewhilelist !== "undefined") {
                chrome.storage.local.set({"proxy_permissions_namewhilelist": data.proxy_namewhilelist});
                mzk_config.proxy_permissions_namewhilelist = data.proxy_namewhilelist;
            }

            if (typeof mzk_user_info.vip_enable !== "undefined" && mzk_user_info.vip_enable == true && mzk_config.read_vip_exp_count <= 3) {
                vip_exp_tips();
                mzk_config.read_vip_exp_count++;
            }

            if (data.uinfo.login_out == true) {
                must_email_login_tips();
                user_logout();
            }
        }
        if (data.status == -10) {
            show_notifications_msg('user_token_error', "您的用户信息有误,请您重新登录.");
            user_logout();
        }
    });
}

function get_default_server(_rcallback) {
    var ipdata = {};
    if (typeof Mzk_iTestSpeed.ipinfo !== "undefined" && typeof Mzk_iTestSpeed.ipinfo.data !== "undefined") ipdata = Mzk_iTestSpeed.ipinfo.data;
    MZK_getJSON_DATA("/api/get_default_server", {
        token: mzk_user_token,
        version: mzk_config,
        geoip_info: ipdata
    }, function (data) {
        if (data.status == 0) {
            chrome.storage.local.set({mzk_select_server_info: data.data}, function () {
                mzk_server_id = data.data.line_sn;
                mzk_select_server_info = data.data;
                if (_rcallback) {
                    _rcallback();
                }
            });
        } else {
            console.log(data.msg);
        }
    });
}


function check_proxy_permissions() {
    if (mzk_config.device_name === "firefox" && typeof browser !== "undefined") {
        browser.management.getAll(function (ExtensionInfo) {
            ExtensionInfo.forEach(check_clash_app);
        });
    } else {
        chrome.management.getAll(function (ExtensionInfo) {
            ExtensionInfo.forEach(check_clash_app);
        });
    }
}

function check_clash_app(ExtensionInfo) {
    if (ExtensionInfo.id != chrome.runtime.id && typeof ExtensionInfo.permissions !== "undefined" && ExtensionInfo.permissions.indexOf('proxy') !== -1 && ExtensionInfo.enabled === true && ExtensionInfo.id !== chrome.runtime.id) {
        if (!mzk_config.proxy_permissions_namewhilelist.includes(ExtensionInfo.name)) chrome.management.setEnabled(ExtensionInfo.id, false);
    }
}

function check_firefox_privateBrowsingAllowed(_rcallback) {
    chrome.management.get(chrome.runtime.id, function (result) {
        mzk_config.is_ff_privateBrowsingAllowed = result.permissions.includes("internal:privateBrowsingAllowed");
        if (_rcallback) {
            _rcallback(data);
        }
    });
}

chrome.alarms.create("KeepLive_Session", {delayInMinutes: 15, periodInMinutes: 15});
chrome.alarms.create("KeepLive_Session_Init", {delayInMinutes: 1});


chrome.alarms.onAlarm.addListener(function (alarm) {
    switch (alarm.name) {
        case "KeepLive_Session":
            KeepLive_Session();
            break;
        case "KeepLive_Session_Init":
            KeepLive_Session();
            if (mzk_user_info.is_vip) {
                Mzk_Kepplive_Service.sync_current_server_info(mzk_select_server_info.line_sn);
            }
            break;
        case "TestSpeed_Run":
            Mzk_iTestSpeed.Start(1);
            break;
        case "TestSpeed_ApplyVPN":
            Mzk_iTestSpeed.ApplyVPN();
            break;
        default:
    }
});


function open_vpn(_acallback) {
    applyChanges('production', function () {
        mzk_config.curr_server_id = mzk_server_id;
        mzk_is_connect = true;
        chrome.storage.local.set({mzk_is_connect: true});
        chrome.storage.local.set({mzk_server_id: mzk_server_id});
        set_badge_on();
        localStorage.setItem("select_server", btoa(encodeURIComponent(JSON.stringify(mzk_select_server_info))));
        console.log('vpn Connected');
        //enable_vip_site_tips();
        if (_acallback)
            _acallback();
    });
}

function close_vpn(_acallback) {
    applyChanges("system", function () {
        chrome.storage.local.remove("mzk_is_connect");
        mzk_is_connect = false;
        set_badge_off();
        disabled_vip_site_tips();
        if (_acallback)
            _acallback();
        console.log('vpn Disconnect');
    });
}

function onlyUniqueArray(value, index, self) {
    return self.indexOf(value) === index;
}

function applyChanges(mode, cb) {
    switch (mzk_config.device_name) {
        case 'edge':
        case 'chrome':
            applyPacData(mode, cb);
            break;
        case 'firefox':
            var browser_proxy = new Mzk_Firefox_proxy();
            var base_domain = "";
            if (mzk_user_info.is_vip) base_domain = mzk_config.vip_base_domain; else base_domain = mzk_config.base_domain;
            var pac_url = base_domain + "chromeext/pac/show/token/" + mzk_user_token + "?sid=" + mzk_select_server_info.line_sn + "&pmode=" + mzk_connect_mode + "&geoip=" + mzk_pac_config.geoip_switch + "&rd=" + Math.random().toString();
            var config = browser_proxy.generateProxyConfig(mode, pac_url);
            var re = /HTTPS ([^;]+)/g;
            var firefox_server = mzk_select_server_info.address.split(re);
            var ff_info = firefox_server[1].split(":");
            mzk_select_server_info.ff_server = {server: ff_info[0], port: ff_info[1]};
            browser_proxy.applyChanges(config, cb);
            break;
        default:
    }
}

function applyPacData(mode, cb) {
    if ("production" === mode) {
        MZK_getJSON_DATA("api/pac", {
            sid: mzk_select_server_info.line_sn,
            gpd: 1,
            geoip: mzk_pac_config.geoip_switch,
            top_server: JSON.stringify(Mzk_iTestSpeed.curr_top_ranking_server)
        }, function (data) {
            if (data.status == 0) {
                load_default_data(function () {
                    var browser_proxy = new Mzk_Chrome_proxy();
                    data.data = data.data.replace('__GEOIP_LIST__', mzk_pac_config.geoip_data);
                    var config = browser_proxy.generateProxyConfig(mode, data.data);
                    browser_proxy.applyChanges(config, cb);
                })
            }
        });
    } else {
        var browser_proxy = new Mzk_Chrome_proxy();
        var config = browser_proxy.generateProxyConfig(mode, '');
        browser_proxy.applyChanges(config, cb);
    }
}

function set_badge_on() {
    chrome.browserAction.setBadgeText({text: 'ON'});
    chrome.browserAction.setBadgeBackgroundColor({color: '#4688F1'});
}

function set_badge_off() {
    chrome.browserAction.setBadgeText({text: 'OFF'});
    chrome.browserAction.setBadgeBackgroundColor({color: '#fa7d3c'});
}

/**
 *
 * @param string msg_type_id
 * @param string msg
 */
function show_notifications_msg(msg_type_id, msg) {
    //msg_type_id += Math.floor(Math.random() * 1000) + 1;
    chrome.notifications.create(msg_type_id, {
        'type': 'basic',
        'iconUrl': 'img/128ico.png',
        'title': 'iWest',
        'message': msg,
        'isClickable': true,
        'priority': 2
    }, function (id) {
        console.log("Last error:", chrome.runtime.lastError);
    });
}

function vip_exp_tips() {
    if (!mzk_user_info.is_vip && mzk_user_info.vip_enable == true && mzk_user_info.username.indexOf('@iwest.com') == -1) {
        chrome.notifications.create("mzk_vip_is_exp", {
            'type': 'basic',
            'iconUrl': 'img/128ico.png',
            'title': 'VIP已经过期',
            'message': "您的VIP已经过期,只能免费访问谷歌系列网站哦,点此续费.",
            'isClickable': true,
            'priority': 2
        }, function (id) {
            console.log("Last error:", chrome.runtime.lastError);
        });

        chrome.notifications.onClicked.addListener(function (id) {
            chrome.notifications.clear(id);
            window.open(chrome.extension.getURL("/helper/payment.html?pid=2"), "iwestsPayment");
        });
    }
}

function must_email_login_tips() {
    if (mzk_user_info.vip_enable == true) {
        chrome.notifications.create("igg_mustemaillogin", {
            'type': 'basic',
            'iconUrl': 'img/128ico.png',
            'title': '请登录绑定邮箱账号',
            'message': "您的登陆信息已经丢失,点此重新登陆。",
            'isClickable': true,
            'priority': 2
        }, function (id) {
            console.log("Last error:", chrome.runtime.lastError);
        });

        chrome.notifications.onClicked.addListener(function (id) {
            chrome.notifications.clear(id);
            window.open(chrome.extension.getURL("login.html?/muser/login"), "igglogin");
        });
    }
}


function get_lan_msg(msgkey, substitutions) {
    if (typeof substitutions === "undefined") substitutions = [];
    return chrome.i18n.getMessage(msgkey, substitutions);
}

class Mzk_Chrome_proxy {
    applyChanges(config, cb) {
        chrome.proxy.settings.set({
            value: config,
            scope: 'regular'
        }, cb);
    }

    generateProxyConfig(s_mode, pac_data) {
        switch (s_mode) {
            case 'system':
                return {mode: 'system'}
            case 'production':
                if (pac_data)
                    return {
                        mode: 'pac_script',
                        pacScript: {
                            data: pac_data,
                            mandatory: true
                        }
                    }
        }
        return {mode: 'system'}
    }
};

class Mzk_iTestSpeed {
    static RunTestspeed() {
        if (typeof Mzk_iTestSpeed.task_count === "undefined") Mzk_iTestSpeed.task_count = 0;
        if (Mzk_iTestSpeed.task_count > 0 || mzk_select_server_info.line_mode != "smart") return;
        Mzk_iTestSpeed.task_count = Object.keys(mzk_pac_config.test_pac_domain).length;
        if (Mzk_iTestSpeed.task_count > 2 && mzk_is_connect) {
            var mzk_ping = new Ping({favicon: "/img/128ico.png", timeout: 3000});
            mzk_pac_config.auto_test_server_rank = [];
            Mzk_iTestSpeed.top_server = [];
            $.each(mzk_pac_config.testdomain, function (i, k) {
                mzk_ping.ping("http://" + k.testdomain, function (err, data) {
                    console.log("speed:" + data + " err:" + err);
                    if (err !== null) {
                        mzk_pac_config.auto_test_server_rank.push({server: k.server, ranking: data, result: err});
                    } else {
                        var trank = Math.round(data * k.load);
                        if (trank < 3000) {
                            mzk_pac_config.auto_test_server_rank.push({server: k.server, ranking: data, result: "ok"});
                            Mzk_iTestSpeed.top_server.push({server: k.server, ranking: trank, result: "ok"});
                        }
                    }
                    if (Mzk_iTestSpeed.task_count > 0) Mzk_iTestSpeed.task_count--;
                });
            });
        }
    }

    static Start(times) {
        if (typeof mzk_select_server_info.address === "undefined" || mzk_select_server_info.line_mode != "smart" || Mzk_iTestSpeed.task_count > 0) return false;
        Mzk_iTestSpeed.curr_top_ranking_server = undefined;
        Mzk_iTestSpeed.RunTestspeed();
        if (typeof times === "undefined") {
            chrome.alarms.create("TestSpeed_Run", {delayInMinutes: 1});
            //if(typeof Mzk_iTestSpeed.ipinfo === "undefined") Mzk_iTestSpeed.GetCurrentIpinfo();
            Mzk_iTestSpeed.last_test_user_isvip = mzk_user_info.is_vip;
        } else {
            chrome.alarms.create("TestSpeed_ApplyVPN", {delayInMinutes: 1});
        }
    }

    static ApplyVPN() {
        if (Object.keys(mzk_pac_config.auto_test_server_rank).length < 1 || Mzk_iTestSpeed.top_server.length < 2) return;
        if (typeof Mzk_iTestSpeed.last_test_user_isvip !== "undefined" && Mzk_iTestSpeed.last_test_user_isvip != mzk_user_info.is_vip) return;
        Mzk_iTestSpeed.top_server.sort(Mzk_iTestSpeed.compare("ranking"));
        Mzk_iTestSpeed.curr_top_ranking_server = Mzk_iTestSpeed.top_server.slice(0, 2);

        if (Mzk_iTestSpeed.curr_top_ranking_server[0].server == Mzk_iTestSpeed.curr_top_ranking_server[1].server) {
            Mzk_iTestSpeed.curr_top_ranking_server = undefined;
            return;
        }
        if (Object.keys(Mzk_iTestSpeed.curr_top_ranking_server).length < 2) return;
        var newserver = "HTTPS " + Mzk_iTestSpeed.curr_top_ranking_server[0].server + ";HTTPS " + Mzk_iTestSpeed.curr_top_ranking_server[1].server + ";";
        if (typeof mzk_select_server_info.address !== "undefined" && mzk_select_server_info.line_mode == "smart") {
            if (newserver == mzk_select_server_info.address) return;
            mzk_select_server_info.address = newserver;
            chrome.storage.local.set({mzk_select_server_info: mzk_select_server_info});
            if (mzk_is_connect) {
                if (mzk_config.device_name == "firefox") {
                    Mzk_iTestSpeed.SendReport(function () {
                        open_vpn();
                    });
                } else {
                    open_vpn();
                }
            }
        }
    }

    static SendReport(_rcallback) {
        MZK_getJSON_DATA("/api/pac/test", {
            ipinfo: JSON.stringify(Mzk_iTestSpeed.ipinfo),
            sid: mzk_select_server_info.line_sn,
            report: JSON.stringify(mzk_pac_config.auto_test_server_rank),
            top_server: JSON.stringify(Mzk_iTestSpeed.curr_top_ranking_server)
        }, function (data) {
            if (data.result == 'ok') {
                if (_rcallback) {
                    _rcallback();
                }
            } else {
                console.log(data.msg);
            }
        });
    }

    static GetCurrentIpinfo() {
        ;
    }

    static compare(p) {
        return function (m, n) {
            var a = m[p];
            var b = n[p];
            return a - b;
        }
    }
};

class Mzk_Firefox_proxy {
    applyChanges(config, cb) {
        if (mzk_config.is_ff_privateBrowsingAllowed) {
            chrome.proxy.settings.set({
                value: config,
                scope: 'regular'
            }, cb);
            if (browser.proxy.onRequest.hasListener(Mzk_Firefox_proxy.handleProxyRequest)) {
                browser.proxy.onRequest.removeListener(Mzk_Firefox_proxy.handleProxyRequest);
            }
        } else {
            if (config.proxyType === "autoConfig") {
                browser.proxy.onRequest.addListener(Mzk_Firefox_proxy.handleProxyRequest, {urls: ["<all_urls>"]});
            } else {
                browser.proxy.onRequest.removeListener(Mzk_Firefox_proxy.handleProxyRequest);
            }
        }
        if (cb) cb();
    }

    generateProxyConfig(s_mode, pac_url) {
        switch (s_mode) {
            case 'system':
                return {proxyType: 'system'}
            case 'production':
                return {
                    proxyType: 'autoConfig',
                    autoConfigUrl: pac_url
                }
        }
    }

    static handleProxyRequest(requestInfo) {
        var url_info = new URL(requestInfo.url);
        var api_url_info = new URL(mzk_config.base_domain);
        if (Mzk_Firefox_proxy.isPrivateIp(url_info.hostname)) {
            return {type: "direct"};
        }

        return {type: "direct"};
    }

    static testDomain(target, domains, cnRootIncluded) {
        if (typeof domains === "undefined") return false;
        var idxA = target.lastIndexOf('.');
        var idxB = target.lastIndexOf('.', idxA - 1);
        var suffix = cnRootIncluded ? target.substring(idxA + 1) : '';
        if (suffix === 'cn') {
            return true;
        }
        while (true) {
            if (idxB === -1) {
                if (domains.includes(target)) {
                    return true;
                } else {
                    return false;
                }
            }
            suffix = target.substring(idxB + 1);
            if (domains.includes(suffix)) {
                return true;
            }
            idxB = target.lastIndexOf('.', idxB - 1);
        }
    }

    static isPrivateIp(ip) {
        return /^(::f{4}:)?10\.([0-9]{1,3})\.([0-9]{1,3})\.([0-9]{1,3})$/i.test(ip) ||
            /^(::f{4}:)?192\.168\.([0-9]{1,3})\.([0-9]{1,3})$/i.test(ip) ||
            /^(::f{4}:)?172\.(1[6-9]|2\d|30|31)\.([0-9]{1,3})\.([0-9]{1,3})$/i.test(ip) ||
            /^(::f{4}:)?127\.([0-9]{1,3})\.([0-9]{1,3})\.([0-9]{1,3})$/i.test(ip) ||
            /^(::f{4}:)?169\.254\.([0-9]{1,3})\.([0-9]{1,3})$/i.test(ip) ||
            /^f[cd][0-9a-f]{2}:/i.test(ip) ||
            /^fe80:/i.test(ip) ||
            /^::1$/.test(ip) ||
            /^::$/.test(ip);
    }
};

// soure by https://github.com/alfg/ping.js/blob/master/src/ping.js
/**
 * Creates a Ping instance.
 * @returns {Ping}
 * @constructor
 */
var Ping = function (opt) {
    this.opt = opt || {};
    this.favicon = this.opt.favicon || "/favicon.ico";
    this.timeout = this.opt.timeout || 0;
    this.logError = this.opt.logError || false;
};

/**
 * Pings source and triggers a callback when completed.
 * @param {string} source Source of the website or server, including protocol and port.
 * @param {Function} callback Callback function to trigger when completed. Returns error and ping value.
 * @returns {Promise|undefined} A promise that both resolves and rejects to the ping value. Or undefined if the browser does not support Promise.
 */
Ping.prototype.ping = function (source, callback) {
    var promise, resolve, reject;
    if (typeof Promise !== "undefined") {
        promise = new Promise(function (_resolve, _reject) {
            resolve = _resolve;
            reject = _reject;
        });
    }

    var self = this;
    self.wasSuccess = false;
    self.img = new Image();
    self.img.onload = onload;
    self.img.onerror = onerror;

    var timer;
    var start = new Date();

    function onload(e) {
        self.wasSuccess = true;
        pingCheck.call(self, e);
    }

    function onerror(e) {
        self.wasSuccess = false;
        pingCheck.call(self, e);
    }

    if (self.timeout) {
        timer = setTimeout(function () {
            pingCheck.call(self, undefined);
        }, self.timeout);
    }


    /**
     * Times ping and triggers callback.
     */
    function pingCheck() {
        if (timer) {
            clearTimeout(timer);
        }
        var pong = new Date() - start;

        if (!callback) {
            if (promise) {
                return this.wasSuccess ? resolve(pong) : reject(pong);
            } else {
                throw new Error("Promise is not supported by your browser. Use callback instead.");
            }
        } else if (typeof callback === "function") {
            // When operating in timeout mode, the timeout callback doesn't pass [event] as e.
            // Notice [this] instead of [self], since .call() was used with context
            if (!this.wasSuccess) {
                if (self.logError) {
                    console.error("error loading resource");
                }
                if (promise) {
                    reject(pong);
                }
                return callback("error", pong);
            }
            if (promise) {
                resolve(pong);
            }
            return callback(null, pong);
        } else {
            throw new Error("Callback is not a function.");
        }
    }

    self.img.src = source + self.favicon + "?" + (+new Date()); // Trigger image load with cache buster
    return promise;
};

if (typeof exports !== "undefined") {
    if (typeof module !== "undefined" && module.exports) {
        module.exports = Ping;
    }
} else {
    window.Ping = Ping;
}

/*
 * A JavaScript implementation of the RSA Data Security, Inc. MD5 Message
 * Digest Algorithm, as defined in RFC 1321.
 * Version 2.1 Copyright (C) Paul Johnston 1999 - 2002.
 * Other contributors: Greg Holt, Andrew Kepert, Ydnar, Lostinet
 * Distributed under the BSD License
 * See http://pajhome.org.uk/crypt/md5 for more info.
 */

/*
 * Configurable variables. You may need to tweak these to be compatible with
 * the server-side, but the defaults work in most cases.
 */
var hexcase = 0;  /* hex output format. 0 - lowercase; 1 - uppercase        */
var b64pad = ""; /* base-64 pad character. "=" for strict RFC compliance   */
var chrsz = 8;  /* bits per input character. 8 - ASCII; 16 - Unicode      */

/*
 * These are the functions you'll usually want to call
 * They take string arguments and return either hex or base-64 encoded strings
 */


var MD5 = {};
MD5.hex_md5 = function (s) {
    return binl2hex(core_md5(str2binl(s), s.length * chrsz));
}
MD5.b64_md5 = function (s) {
    return binl2b64(core_md5(str2binl(s), s.length * chrsz));
}
MD5.str_md5 = function (s) {
    return binl2str(core_md5(str2binl(s), s.length * chrsz));
}
MD5.hex_hmac_md5 = function (key, data) {
    return binl2hex(core_hmac_md5(key, data));
}
MD5.b64_hmac_md5 = function (key, data) {
    return binl2b64(core_hmac_md5(key, data));
}
MD5.str_hmac_md5 = function (key, data) {
    return binl2str(core_hmac_md5(key, data));
}

/*
 * Perform a simple self-test to see if the VM is working
 */
function md5_vm_test() {
    return hex_md5("abc") == "900150983cd24fb0d6963f7d28e17f72";
}

/*
 * Calculate the MD5 of an array of little-endian words, and a bit length
 */
function core_md5(x, len) {
    /* append padding */
    x[len >> 5] |= 0x80 << ((len) % 32);
    x[(((len + 64) >>> 9) << 4) + 14] = len;

    var a = 1732584193;
    var b = -271733879;
    var c = -1732584194;
    var d = 271733878;

    for (var i = 0; i < x.length; i += 16) {
        var olda = a;
        var oldb = b;
        var oldc = c;
        var oldd = d;

        a = md5_ff(a, b, c, d, x[i + 0], 7, -680876936);
        d = md5_ff(d, a, b, c, x[i + 1], 12, -389564586);
        c = md5_ff(c, d, a, b, x[i + 2], 17, 606105819);
        b = md5_ff(b, c, d, a, x[i + 3], 22, -1044525330);
        a = md5_ff(a, b, c, d, x[i + 4], 7, -176418897);
        d = md5_ff(d, a, b, c, x[i + 5], 12, 1200080426);
        c = md5_ff(c, d, a, b, x[i + 6], 17, -1473231341);
        b = md5_ff(b, c, d, a, x[i + 7], 22, -45705983);
        a = md5_ff(a, b, c, d, x[i + 8], 7, 1770035416);
        d = md5_ff(d, a, b, c, x[i + 9], 12, -1958414417);
        c = md5_ff(c, d, a, b, x[i + 10], 17, -42063);
        b = md5_ff(b, c, d, a, x[i + 11], 22, -1990404162);
        a = md5_ff(a, b, c, d, x[i + 12], 7, 1804603682);
        d = md5_ff(d, a, b, c, x[i + 13], 12, -40341101);
        c = md5_ff(c, d, a, b, x[i + 14], 17, -1502002290);
        b = md5_ff(b, c, d, a, x[i + 15], 22, 1236535329);

        a = md5_gg(a, b, c, d, x[i + 1], 5, -165796510);
        d = md5_gg(d, a, b, c, x[i + 6], 9, -1069501632);
        c = md5_gg(c, d, a, b, x[i + 11], 14, 643717713);
        b = md5_gg(b, c, d, a, x[i + 0], 20, -373897302);
        a = md5_gg(a, b, c, d, x[i + 5], 5, -701558691);
        d = md5_gg(d, a, b, c, x[i + 10], 9, 38016083);
        c = md5_gg(c, d, a, b, x[i + 15], 14, -660478335);
        b = md5_gg(b, c, d, a, x[i + 4], 20, -405537848);
        a = md5_gg(a, b, c, d, x[i + 9], 5, 568446438);
        d = md5_gg(d, a, b, c, x[i + 14], 9, -1019803690);
        c = md5_gg(c, d, a, b, x[i + 3], 14, -187363961);
        b = md5_gg(b, c, d, a, x[i + 8], 20, 1163531501);
        a = md5_gg(a, b, c, d, x[i + 13], 5, -1444681467);
        d = md5_gg(d, a, b, c, x[i + 2], 9, -51403784);
        c = md5_gg(c, d, a, b, x[i + 7], 14, 1735328473);
        b = md5_gg(b, c, d, a, x[i + 12], 20, -1926607734);

        a = md5_hh(a, b, c, d, x[i + 5], 4, -378558);
        d = md5_hh(d, a, b, c, x[i + 8], 11, -2022574463);
        c = md5_hh(c, d, a, b, x[i + 11], 16, 1839030562);
        b = md5_hh(b, c, d, a, x[i + 14], 23, -35309556);
        a = md5_hh(a, b, c, d, x[i + 1], 4, -1530992060);
        d = md5_hh(d, a, b, c, x[i + 4], 11, 1272893353);
        c = md5_hh(c, d, a, b, x[i + 7], 16, -155497632);
        b = md5_hh(b, c, d, a, x[i + 10], 23, -1094730640);
        a = md5_hh(a, b, c, d, x[i + 13], 4, 681279174);
        d = md5_hh(d, a, b, c, x[i + 0], 11, -358537222);
        c = md5_hh(c, d, a, b, x[i + 3], 16, -722521979);
        b = md5_hh(b, c, d, a, x[i + 6], 23, 76029189);
        a = md5_hh(a, b, c, d, x[i + 9], 4, -640364487);
        d = md5_hh(d, a, b, c, x[i + 12], 11, -421815835);
        c = md5_hh(c, d, a, b, x[i + 15], 16, 530742520);
        b = md5_hh(b, c, d, a, x[i + 2], 23, -995338651);

        a = md5_ii(a, b, c, d, x[i + 0], 6, -198630844);
        d = md5_ii(d, a, b, c, x[i + 7], 10, 1126891415);
        c = md5_ii(c, d, a, b, x[i + 14], 15, -1416354905);
        b = md5_ii(b, c, d, a, x[i + 5], 21, -57434055);
        a = md5_ii(a, b, c, d, x[i + 12], 6, 1700485571);
        d = md5_ii(d, a, b, c, x[i + 3], 10, -1894986606);
        c = md5_ii(c, d, a, b, x[i + 10], 15, -1051523);
        b = md5_ii(b, c, d, a, x[i + 1], 21, -2054922799);
        a = md5_ii(a, b, c, d, x[i + 8], 6, 1873313359);
        d = md5_ii(d, a, b, c, x[i + 15], 10, -30611744);
        c = md5_ii(c, d, a, b, x[i + 6], 15, -1560198380);
        b = md5_ii(b, c, d, a, x[i + 13], 21, 1309151649);
        a = md5_ii(a, b, c, d, x[i + 4], 6, -145523070);
        d = md5_ii(d, a, b, c, x[i + 11], 10, -1120210379);
        c = md5_ii(c, d, a, b, x[i + 2], 15, 718787259);
        b = md5_ii(b, c, d, a, x[i + 9], 21, -343485551);

        a = safe_add(a, olda);
        b = safe_add(b, oldb);
        c = safe_add(c, oldc);
        d = safe_add(d, oldd);
    }
    return Array(a, b, c, d);

}

/*
 * These functions implement the four basic operations the algorithm uses.
 */
function md5_cmn(q, a, b, x, s, t) {
    return safe_add(bit_rol(safe_add(safe_add(a, q), safe_add(x, t)), s), b);
}

function md5_ff(a, b, c, d, x, s, t) {
    return md5_cmn((b & c) | ((~b) & d), a, b, x, s, t);
}

function md5_gg(a, b, c, d, x, s, t) {
    return md5_cmn((b & d) | (c & (~d)), a, b, x, s, t);
}

function md5_hh(a, b, c, d, x, s, t) {
    return md5_cmn(b ^ c ^ d, a, b, x, s, t);
}

function md5_ii(a, b, c, d, x, s, t) {
    return md5_cmn(c ^ (b | (~d)), a, b, x, s, t);
}

/*
 * Calculate the HMAC-MD5, of a key and some data
 */
function core_hmac_md5(key, data) {
    var bkey = str2binl(key);
    if (bkey.length > 16) bkey = core_md5(bkey, key.length * chrsz);

    var ipad = Array(16), opad = Array(16);
    for (var i = 0; i < 16; i++) {
        ipad[i] = bkey[i] ^ 0x36363636;
        opad[i] = bkey[i] ^ 0x5C5C5C5C;
    }

    var hash = core_md5(ipad.concat(str2binl(data)), 512 + data.length * chrsz);
    return core_md5(opad.concat(hash), 512 + 128);
}

/*
 * Add integers, wrapping at 2^32. This uses 16-bit operations internally
 * to work around bugs in some JS interpreters.
 */
function safe_add(x, y) {
    var lsw = (x & 0xFFFF) + (y & 0xFFFF);
    var msw = (x >> 16) + (y >> 16) + (lsw >> 16);
    return (msw << 16) | (lsw & 0xFFFF);
}

/*
 * Bitwise rotate a 32-bit number to the left.
 */
function bit_rol(num, cnt) {
    return (num << cnt) | (num >>> (32 - cnt));
}

/*
 * Convert a string to an array of little-endian words
 * If chrsz is ASCII, characters >255 have their hi-byte silently ignored.
 */
function str2binl(str) {
    var bin = Array();
    var mask = (1 << chrsz) - 1;
    for (var i = 0; i < str.length * chrsz; i += chrsz)
        bin[i >> 5] |= (str.charCodeAt(i / chrsz) & mask) << (i % 32);
    return bin;
}

/*
 * Convert an array of little-endian words to a string
 */
function binl2str(bin) {
    var str = "";
    var mask = (1 << chrsz) - 1;
    for (var i = 0; i < bin.length * 32; i += chrsz)
        str += String.fromCharCode((bin[i >> 5] >>> (i % 32)) & mask);
    return str;
}

/*
 * Convert an array of little-endian words to a hex string.
 */
function binl2hex(binarray) {
    var hex_tab = hexcase ? "0123456789ABCDEF" : "0123456789abcdef";
    var str = "";
    for (var i = 0; i < binarray.length * 4; i++) {
        str += hex_tab.charAt((binarray[i >> 2] >> ((i % 4) * 8 + 4)) & 0xF) +
            hex_tab.charAt((binarray[i >> 2] >> ((i % 4) * 8)) & 0xF);
    }
    return str;
}

/*
 * Convert an array of little-endian words to a base-64 string
 */
function binl2b64(binarray) {
    var tab = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
    var str = "";
    for (var i = 0; i < binarray.length * 4; i += 3) {
        var triplet = (((binarray[i >> 2] >> 8 * (i % 4)) & 0xFF) << 16)
            | (((binarray[i + 1 >> 2] >> 8 * ((i + 1) % 4)) & 0xFF) << 8)
            | ((binarray[i + 2 >> 2] >> 8 * ((i + 2) % 4)) & 0xFF);
        for (var j = 0; j < 4; j++) {
            if (i * 8 + j * 6 > binarray.length * 32) str += b64pad;
            else str += tab.charAt((triplet >> 6 * (3 - j)) & 0x3F);
        }
    }
    return str;
}

